<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Graph.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean</a> &gt; <span class="el_source">Graph.java</span></div><h1>Graph.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Objects;

import io.gitlab.littlesaints.protean.configuration.Configuration;
import io.gitlab.littlesaints.protean.configuration.GraphOptions;
import io.gitlab.littlesaints.protean.resources.ResourceLocator;

import lombok.Builder;
import lombok.NonNull;
import lombok.Singular;
import lombok.Value;

/**
 * Defines a complete processing workflow / pipeline. It includes all the processing {@link Node}s and their inter-dependencies.
 *
 * @see Node
 * @see Context
 */
<span class="nc bnc" id="L46" title="All 52 branches missed.">@Value</span>
public final class Graph&lt;E&gt; {

<span class="nc" id="L49">    private final Collection &lt;Node &lt;E&gt;&gt; nodes;</span>

<span class="fc" id="L51">    private final Map &lt;String, Collection &lt;String&gt;&gt; dependencies;</span>

<span class="fc" id="L53">    private final Collection &lt;String&gt; roots;</span>

<span class="nc" id="L55">    private final Collection &lt;String&gt; leaves;</span>

<span class="fc" id="L57">    private final Map &lt;String, Collection &lt;String&gt;&gt; hierarchy;</span>

<span class="fc" id="L59">    private final Map &lt;String, Node &lt;E&gt;&gt; nodesMap;</span>

    public static &lt;E&gt; Graph&lt;E&gt; of(Collection &lt;Node&lt;E&gt;&gt; nodes) {
<span class="nc" id="L62">        return new Graph&lt;&gt;(nodes, Collections.emptyMap());</span>
    }

<span class="pc bpc" id="L65" title="13 of 28 branches missed.">    @Builder</span>
<span class="pc bpc" id="L66" title="1 of 2 branches missed.">    private Graph(@Singular @NonNull Collection&lt;Node &lt;E&gt;&gt; nodes, @Singular Map&lt;String, Collection &lt;String&gt;&gt; dependencies) {</span>
<span class="fc" id="L67">        this.nodes = Collections.unmodifiableCollection(nodes);</span>
<span class="pc bpc" id="L68" title="1 of 2 branches missed.">        this.dependencies = dependencies == null ? Collections.emptyMap() : Collections.unmodifiableMap(dependencies);</span>
<span class="fc" id="L69">        this.roots = Collections.unmodifiableCollection(evaluateRoots(this.nodes, this.dependencies));</span>
<span class="fc" id="L70">        this.hierarchy = Collections.unmodifiableMap(evaluateHierarchy(this.dependencies));</span>
<span class="fc" id="L71">        this.leaves = Collections.unmodifiableCollection(evaluateLeaves(this.nodes, this.hierarchy));</span>
<span class="fc" id="L72">        this.nodesMap = Collections.unmodifiableMap(evaluateNodesMap(this.nodes));</span>
<span class="fc" id="L73">        validate();</span>
<span class="fc" id="L74">    }</span>

<span class="pc bpc" id="L76" title="3 of 6 branches missed.">    @Builder(builderClassName = &quot;GraphConfigurer&quot;, builderMethodName = &quot;configure&quot;, buildMethodName = &quot;get&quot;)</span>
<span class="pc bpc" id="L77" title="3 of 6 branches missed.">    private static &lt;E&gt; Graph &lt;E&gt; from(@NonNull Configuration configuration, @NonNull ResourceLocator locator, @NonNull GraphOptions options/*, @NonNull EventAccessor accessor*/) {</span>
<span class="fc" id="L78">        GraphBuilder &lt;E&gt; builder = Graph.builder();</span>
<span class="fc" id="L79">        options.getStages().stream()</span>
<span class="fc" id="L80">            .map(o -&gt; Node.&lt;E&gt;configure().configuration(configuration).locator(locator).options(o)/*.accessor(accessor)*/.get())</span>
<span class="fc" id="L81">            .forEach(builder::node);</span>
<span class="fc" id="L82">        builder.dependencies(options.getDependencies());</span>
<span class="fc" id="L83">        return builder.build();</span>
    }

    private void validate() {
<span class="pc bpc" id="L87" title="1 of 2 branches missed.">        if (nodes.isEmpty()) {</span>
<span class="nc" id="L88">            throw new RuntimeException(&quot;nodes not configured !!&quot;);</span>
        }

<span class="fc" id="L91">        Objects.requireNonNull(roots, &quot;roots cannot be null !!&quot;);</span>
<span class="pc bpc" id="L92" title="1 of 2 branches missed.">        if (roots.isEmpty()) {</span>
<span class="nc" id="L93">            throw new RuntimeException(&quot;roots not configured !!&quot;);</span>
        }

<span class="fc" id="L96">        Objects.requireNonNull(leaves, &quot;leaves cannot be null !!&quot;);</span>
<span class="pc bpc" id="L97" title="1 of 2 branches missed.">        if (leaves.isEmpty()) {</span>
<span class="nc" id="L98">            throw new RuntimeException(&quot;leaves not configured !!&quot;);</span>
        }

<span class="fc" id="L101">        Objects.requireNonNull(nodesMap, &quot;nodesMap cannot be null !!&quot;);</span>
<span class="pc bpc" id="L102" title="1 of 2 branches missed.">        if (nodesMap.isEmpty()) {</span>
<span class="nc" id="L103">            throw new RuntimeException(&quot;nodesMap not configured !!&quot;);</span>
        }

<span class="pc bpc" id="L106" title="1 of 2 branches missed.">        if (new HashSet &lt;&gt;(nodes).size() != nodes.size()) {</span>
<span class="nc" id="L107">            throw new RuntimeException(&quot;Found multiple nodes newInstance the same name !!&quot;);</span>
        }
<span class="fc" id="L109">    }</span>

    private Map &lt;String, Collection &lt;String&gt;&gt; evaluateHierarchy(Map &lt;String, Collection &lt;String&gt;&gt; dependencies) {
<span class="fc" id="L112">        final Map &lt;String, Collection &lt;String&gt;&gt; hierarchy = new HashMap &lt;&gt;(dependencies.size());</span>
<span class="fc" id="L113">        dependencies.forEach((s, d) -&gt; {</span>
<span class="fc" id="L114">            Collection &lt;String&gt; list = Collections.singleton(s);</span>
<span class="fc" id="L115">            d.forEach(v -&gt;</span>
<span class="fc" id="L116">                hierarchy.merge(v, new ArrayList &lt;&gt;(list), (o, n) -&gt; {</span>
<span class="fc" id="L117">                    o.addAll(n);</span>
<span class="fc" id="L118">                    return o;</span>
                })
            );
<span class="fc" id="L121">        });</span>
<span class="fc" id="L122">        return hierarchy;</span>
    }

    private Collection &lt;String&gt; evaluateRoots(Collection &lt;Node &lt;E&gt;&gt; nodes, Map &lt;String, Collection &lt;String&gt;&gt; dependencies) {
<span class="fc" id="L126">        final Collection &lt;String&gt; roots = new ArrayList &lt;&gt;(1);</span>
<span class="fc bfc" id="L127" title="All 2 branches covered.">        for (Node &lt;E&gt; node : nodes) {</span>
<span class="fc bfc" id="L128" title="All 2 branches covered.">            if (!dependencies.containsKey(node.getName())) {</span>
<span class="fc" id="L129">                roots.add(node.getName());</span>
            }
<span class="fc" id="L131">        }</span>
<span class="fc" id="L132">        return roots;</span>
    }

    private Collection &lt;String&gt; evaluateLeaves(Collection &lt;Node &lt;E&gt;&gt; nodes, Map &lt;String, Collection &lt;String&gt;&gt; hierarchy) {
<span class="fc" id="L136">        final Collection &lt;String&gt; leaves = new ArrayList &lt;&gt;(1);</span>
<span class="fc bfc" id="L137" title="All 2 branches covered.">        for (Node &lt;E&gt; node : nodes) {</span>
<span class="fc bfc" id="L138" title="All 2 branches covered.">            if (!hierarchy.containsKey(node.getName())) {</span>
<span class="fc" id="L139">                leaves.add(node.getName());</span>
            }
<span class="fc" id="L141">        }</span>
<span class="fc" id="L142">        return leaves;</span>
    }

    private Map &lt;String, Node &lt;E&gt;&gt; evaluateNodesMap(Collection &lt;Node &lt;E&gt;&gt; nodes) {
<span class="fc" id="L146">        final Map &lt;String, Node &lt;E&gt;&gt; nodesMap = new HashMap &lt;&gt;(nodes.size());</span>
<span class="fc bfc" id="L147" title="All 2 branches covered.">        for (Node &lt;E&gt; node : nodes) {</span>
<span class="fc" id="L148">            nodesMap.put(node.getName(), node);</span>
<span class="fc" id="L149">        }</span>
<span class="fc" id="L150">        return nodesMap;</span>
    }

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>